#ifndef __INTERRUPT_H__
#define __INTERRUPT_H__

#define AINT 1

typedef struct 
{
void *Address;
int Source;
void (*func)(int);
} Interrupt;

void Interrupt_SetISR(void (*isr)(int), Interrupt *interrupt);
void Interrupt_SetSignal(int sig, Interrupt *interrupt);
#endif